## deepin-unioncode 1.3.8

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

project(deepin-unioncode)

message("processor: ${CMAKE_SYSTEM_PROCESSOR}")

function(print_directory arg)
    execute_process(COMMAND ls ${ARGV0} OUTPUT_VARIABLE outVar)
    message(STATUS "print_directory native: ${ARGV0}\n" ${outVar})
endfunction()

set(VERSION $ENV{VERSION})
if (NOT VERSION)
    set(VERSION "0.0.1")
endif()

message(STATUS "build version ${VERSION}")
option(ENABLE_SANITIZE_CHECK "Enable Sanitize Check " OFF) 

set(CMAKE_VERBOSE_MAKEFILE ON)

if (ENABLE_SANITIZE_CHECK AND (CMAKE_BUILD_TYPE STREQUAL "Debug"))
    message("debug type open sanitize check")
    set(CMAKE_CXX_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
    set(CMAKE_C_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
    set(CMAKE_L_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
#    set(CMAKE_CXX_FLAGS "-fsanitize=thread")
#    set(CMAKE_C_FLAGS "-fsanitize=thread")
#    set(CMAKE_L_FLAGS "-fsanitize=thread")
endif()

set(LIBRARY_INSTALL_PREFIX "/usr/lib/${CMAKE_LIBRARY_ARCHITECTURE}/${PROJECT_NAME}")

#set(ARCHIVE_INSTALL_RPEFIX "") undefined the static lib archive
set(RUNTIME_INSTALL_RPEFIX "/usr/bin")
set(SOURCES_INSTALL_RPEFIX "/usr/share/${PROJECT_NAME}")
set(INCLUDE_INSTALL_RPEFIX "/usr/include/${PROJECT_NAME}")

set(PLUGIN_INSTALL_PATH ${LIBRARY_INSTALL_PREFIX}/plugins)
set(TOOLS_INSTALL_PATH ${LIBRARY_INSTALL_PREFIX}/tools)
# set install runtime path
set(CMAKE_INSTALL_RPATH ${LIBRARY_INSTALL_PREFIX} ${PLUGIN_PATH})

message(STATUS "LIBRARY_INSTALL_PREFIX ${LIBRARY_INSTALL_PREFIX}")
message(STATUS "RUNTIME_INSTALL_RPEFIX ${RUNTIME_INSTALL_RPEFIX}")
message(STATUS "SOURCES_INSTALL_RPEFIX ${SOURCES_INSTALL_RPEFIX}")
message(STATUS "INCLUDE_INSTALL_RPEFIX ${INCLUDE_INSTALL_RPEFIX}")
message(STATUS "PLUGIN_INSTALL_PATH ${PLUGIN_INSTALL_PATH}")
message(STATUS "TOOLS_INSTALL_PATH ${TOOLS_INSTALL_PATH}")
message(STATUS "CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_RPATH}")

# build runtime path
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/build/${CMAKE_BUILD_TYPE})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/build/${CMAKE_BUILD_TYPE})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/build/${CMAKE_BUILD_TYPE})
link_directories(${CMAKE_LIBRARY_OUTPUT_DIRECTORY})

add_definitions(-DQT_MESSAGELOGCONTEXT)

# Setup the environment
set(CMAKE_CXX_STANDARD 17)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

if ((${CMAKE_SYSTEM_PROCESSOR} STREQUAL "sw_64")
        OR (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "loongarch64")
        OR (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "mips64")
        )
    message(STATUS "add cmake params found thread library from ${CMAKE_SYSTEM_PROCESSOR}")
    set(CMAKE_THREAD_LIBS_INIT "-lpthread")
    set(CMAKE_HAVE_THREADS_LIBRARY ON)
    set(CMAKE_USE_WIN32_THREADS_INIT OFF)
    set(CMAKE_USE_PTHREADS_INIT ON)
    set(THREADS_PREFER_PTHREAD_FLAG ON)
endif()

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wl,--as-need -fPIE")

find_package(Dtk COMPONENTS Widget REQUIRED)
include_directories(${PROJECT_NAME} PRIVATE ${DtkWidget_INCLUDE_DIRS})

# Use Qt modules no WebEngineWidgets WebChannel
set(QtFindModules Core Gui Widgets Concurrent Network DBus)
foreach(QtModule ${QtFindModules})
    find_package(Qt5 COMPONENTS ${QtModule} REQUIRED)
    # include qt module private include directors
    include_directories(${Qt5${QtModule}_PRIVATE_INCLUDE_DIRS})
    # can use target_link_libraries(xxx ${QtUseModules})
    list(APPEND QtUseModules "Qt5::${QtModule}")
    message("QtModule found ${QtModule} OK!")
endforeach()

set(PkgConfigFindModules)
include(FindPkgConfig)
foreach(PkgConfigModule ${PkgConfigFindModules})
    pkg_check_modules(PkgUseModuleVal REQUIRED ${PkgConfigModule})
    list(APPEND PkgUseModules ${PkgUseModuleVal_LDFLAGS})
    include_directories(${PkgUseModuleVal_INCLUDE_DIRS})
endforeach(PkgConfigModule)

include_directories(${PROJECT_SOURCE_DIR}/src)

option(ENABLE_UNIT_TESTS "Enable unit tests" OFF)
message(STATUS "Enable testing: ${ENABLE_UNIT_TESTS}")
if(ENABLE_UNIT_TESTS)
    enable_testing()
    add_subdirectory(tests)
endif()

# sub directories
add_subdirectory(3rdparty)
add_subdirectory(src)
add_subdirectory(assets)

=== 3rdparty/CMakeLists.txt ===
add_subdirectory(cppdap)
add_subdirectory(unioncode-GitQlient)
add_subdirectory(unioncode-qscintilla214)
add_subdirectory(unioncode-qtermwidget-0.14.1)
add_subdirectory(unioncode-jsonrpccpp)

=== assets/CMakeLists.txt ===
# install templates.
install(DIRECTORY templates/
    DESTINATION "${SOURCES_INSTALL_RPEFIX}/templates")

find_package(Qt5 COMPONENTS LinguistTools)

# install translation.
if (CMAKE_BUILD_TYPE STREQUAL "Release")
    file(GLOB TS_FILES "translations/*.ts")
    foreach(TS_FILE IN LISTS TS_FILES)
        message(STATUS "process ts file: ${TS_FILE}")
        find_program(LUPDATE_COMMAND NAMES lupdate lupdate-qt5 lupdate-qt4 lupdate-pro)
        if (NOT LUPDATE_COMMAND)
            message(FATAL_ERROR "lupdate command not found")
        endif()
        execute_process(COMMAND ${LUPDATE_COMMAND} "${CMAKE_SOURCE_DIR}/src/" -ts -no-obsolete
            "${TS_FILE}"
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            OUTPUT_VARIABLE OUTPUT
            ERROR_VARIABLE ERROR
            RESULT_VARIABLE RES)
        if (RES)
            message(FATAL_ERROR "process ts file result : ${RES}, with error: ${ERROR}")
        endif()
        message(STATUS "${OUTPUT}")
        execute_process(COMMAND lrelease ${TS_FILE})
    endforeach()
endif()

file(GLOB QM_FILES "translations/*.qm")
install(FILES ${QM_FILES} DESTINATION "${SOURCES_INSTALL_RPEFIX}/translations")

# install tools
set(TOOL_INSTALL_PATH "/usr/lib/${CMAKE_LIBRARY_ARCHITECTURE}/${CMAKE_PROJECT_NAME}/tools/env")
message("tool install path: ${TOOL_INSTALL_PATH}")
file(GLOB TOOL_FILES "${CMAKE_SOURCE_DIR}/assets/tools/*.tar.gz")
message(STATUS "TOOL_FILES ${TOOL_FILES}")
install(FILES ${TOOL_FILES} DESTINATION ${TOOL_INSTALL_PATH})

# install configure files.
file(GLOB SUPPORTFILES "${CMAKE_CURRENT_SOURCE_DIR}/configures/*.support")
file(GLOB DESKTOPFILES "${CMAKE_CURRENT_SOURCE_DIR}/configures/*.desktop")
file(GLOB ICON "${CMAKE_CURRENT_SOURCE_DIR}/configures/*.svg")

install(FILES ${SUPPORTFILES} DESTINATION "${SOURCES_INSTALL_RPEFIX}/configures")
install(FILES ${DESKTOPFILES} DESTINATION "/usr/share/applications")
install(FILES ${ICON} DESTINATION "${SOURCES_INSTALL_RPEFIX}/configures/icons")

=== src/CMakeLists.txt ===
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# use outside framework from deepin framework
include_directories(${CMAKE_SOURCE_DIR})
add_subdirectory(framework)
link_libraries(framework)

add_subdirectory(app)
add_subdirectory(base)
add_subdirectory(common)
add_subdirectory(plugins)
add_subdirectory(services)
add_subdirectory(scripts)
add_subdirectory(tools)

=== 3rdparty/cppdap/CMakeLists.txt ===
# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.


cmake_minimum_required(VERSION 2.8)

set (CMAKE_CXX_STANDARD 11)

project(cppdap C CXX)

###########################################################
# Options
###########################################################
function (option_if_not_defined name description default)
    if(NOT DEFINED ${name})
        option(${name} ${description} ${default})
    endif()
endfunction()

option_if_not_defined(CPPDAP_WARNINGS_AS_ERRORS "Treat warnings as errors" OFF)
option_if_not_defined(CPPDAP_BUILD_EXAMPLES "Build example applications" OFF)
option_if_not_defined(CPPDAP_BUILD_TESTS "Build tests" OFF)
option_if_not_defined(CPPDAP_BUILD_FUZZER "Build fuzzer" OFF)
option_if_not_defined(CPPDAP_ASAN "Build dap with address sanitizer" OFF)
option_if_not_defined(CPPDAP_MSAN "Build dap with memory sanitizer" OFF)
option_if_not_defined(CPPDAP_TSAN "Build dap with thread sanitizer" OFF)
option_if_not_defined(CPPDAP_INSTALL_VSCODE_EXAMPLES "Build and install dap examples into vscode extensions directory" OFF)

###########################################################
# Directories
###########################################################
function (set_if_not_defined name value)
    if(NOT DEFINED ${name})
        set(${name} ${value} PARENT_SCOPE)
    endif()
endfunction()

set(CPPDAP_SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)
set(CPPDAP_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set_if_not_defined(CPPDAP_THIRD_PARTY_DIR ${CMAKE_CURRENT_SOURCE_DIR}/third_party)
set_if_not_defined(CPPDAP_JSON_DIR        ${CPPDAP_THIRD_PARTY_DIR}/json)
set_if_not_defined(CPPDAP_GOOGLETEST_DIR  ${CPPDAP_THIRD_PARTY_DIR}/googletest)

###########################################################
# Submodules
###########################################################
if(CPPDAP_BUILD_TESTS)
    if(NOT EXISTS ${CPPDAP_GOOGLETEST_DIR}/.git)
        message(WARNING "third_party/googletest submodule missing.")
        message(WARNING "Run: `git submodule update --init` to build tests.")
        set(CPPDAP_BUILD_TESTS OFF)
    endif()
endif(CPPDAP_BUILD_TESTS)

###########################################################
# JSON library
###########################################################
if(NOT DEFINED CPPDAP_JSON_LIBRARY)
    # Attempt to detect JSON library from CPPDAP_JSON_DIR
    if(NOT EXISTS "${CPPDAP_JSON_DIR}")
        message(FATAL_ERROR "CPPDAP_JSON_DIR '${CPPDAP_JSON_DIR}' does not exist")
    endif()

    if(EXISTS "${CPPDAP_JSON_DIR}/include/nlohmann")
        set(CPPDAP_JSON_LIBRARY "nlohmann")
    elseif(EXISTS "${CPPDAP_JSON_DIR}/include/rapidjson")
        set(CPPDAP_JSON_LIBRARY "rapid")
    else()
        message(FATAL_ERROR "Could not determine JSON library from ${CPPDAP_JSON_LIBRARY}")
    endif()
endif()
string(TOUPPER ${CPPDAP_JSON_LIBRARY} CPPDAP_JSON_LIBRARY_UPPER)

###########################################################
# File lists
###########################################################
set(CPPDAP_LIST
    ${CPPDAP_SRC_DIR}/content_stream.cpp
    ${CPPDAP_SRC_DIR}/io.cpp
    ${CPPDAP_SRC_DIR}/${CPPDAP_JSON_LIBRARY}_json_serializer.cpp
    ${CPPDAP_SRC_DIR}/network.cpp
    ${CPPDAP_SRC_DIR}/null_json_serializer.cpp
    ${CPPDAP_SRC_DIR}/protocol_events.cpp
    ${CPPDAP_SRC_DIR}/protocol_requests.cpp
    ${CPPDAP_SRC_DIR}/protocol_response.cpp
    ${CPPDAP_SRC_DIR}/protocol_types.cpp
    ${CPPDAP_SRC_DIR}/session.cpp
    ${CPPDAP_SRC_DIR}/socket.cpp
    ${CPPDAP_SRC_DIR}/typeinfo.cpp
    ${CPPDAP_SRC_DIR}/typeof.cpp
)

###########################################################
# OS libraries
###########################################################
if(CMAKE_SYSTEM_NAME MATCHES "Windows")
    set(CPPDAP_OS_LIBS WS2_32)
    set(CPPDAP_OS_EXE_EXT ".exe")
elseif(CMAKE_SYSTEM_NAME MATCHES "Linux")
    set(CPPDAP_OS_LIBS pthread)
    set(CPPDAP_OS_EXE_EXT "")
elseif(CMAKE_SYSTEM_NAME MATCHES "Darwin")
    set(CPPDAP_OS_LIBS)
    set(CPPDAP_OS_EXE_EXT "")
endif()

###########################################################
# Functions
###########################################################
function(cppdap_set_target_options target)
    # Enable all warnings
    if(MSVC)
        target_compile_options(${target} PRIVATE "-W4")
    else()
        target_compile_options(${target} PRIVATE "-Wall")
    endif()

    # Disable specific, pedantic warnings
    if(MSVC)
        target_compile_options(${target} PRIVATE
            "-D_CRT_SECURE_NO_WARNINGS"

            # Warnings from nlohmann/json headers.
            "/wd4267" # 'argument': conversion from 'size_t' to 'int', possible loss of data
        )
    endif()

    # Add define for JSON library in use
    set_target_properties(${target} PROPERTIES
        COMPILE_DEFINITIONS "CPPDAP_JSON_${CPPDAP_JSON_LIBRARY_UPPER}=1"
    )

    # Treat all warnings as errors
    if(CPPDAP_WARNINGS_AS_ERRORS)
        if(MSVC)
            target_compile_options(${target} PRIVATE "/WX")
        else()
            target_compile_options(${target} PRIVATE "-Werror")
        endif()
    endif(CPPDAP_WARNINGS_AS_ERRORS)

    if(CPPDAP_ASAN)
        target_compile_options(${target} PUBLIC "-fsanitize=address")
        target_link_libraries(${target} "-fsanitize=address")
    elseif(CPPDAP_MSAN)
        target_compile_options(${target} PUBLIC "-fsanitize=memory")
        target_link_libraries(${target} "-fsanitize=memory")
    elseif(CPPDAP_TSAN)
        target_compile_options(${target} PUBLIC "-fsanitize=thread")
        target_link_libraries(${target} "-fsanitize=thread")
    endif()

    # Error on undefined symbols
    # if(NOT MSVC)
    #     target_compile_options(${target} PRIVATE "-Wl,--no-undefined")
    # endif()

    target_include_directories(${target} PUBLIC ${CPPDAP_INCLUDE_DIR})
endfunction(cppdap_set_target_options)

###########################################################
# Targets
###########################################################

# dap
add_library(cppdap STATIC ${CPPDAP_LIST})
set_target_properties(cppdap PROPERTIES POSITION_INDEPENDENT_CODE 1)

target_include_directories(cppdap PRIVATE "${CPPDAP_JSON_DIR}/include/")

cppdap_set_target_options(cppdap)

target_link_libraries(cppdap "${CPPDAP_OS_LIBS}")

# tests
if(CPPDAP_BUILD_TESTS)
    set(DAP_TEST_LIST
        ${CPPDAP_SRC_DIR}/any_test.cpp
        ${CPPDAP_SRC_DIR}/chan_test.cpp
        ${CPPDAP_SRC_DIR}/content_stream_test.cpp
        ${CPPDAP_SRC_DIR}/dap_test.cpp
        ${CPPDAP_SRC_DIR}/json_serializer_test.cpp
        ${CPPDAP_SRC_DIR}/network_test.cpp
        ${CPPDAP_SRC_DIR}/optional_test.cpp
        ${CPPDAP_SRC_DIR}/rwmutex_test.cpp
        ${CPPDAP_SRC_DIR}/session_test.cpp
        ${CPPDAP_SRC_DIR}/socket_test.cpp
        ${CPPDAP_SRC_DIR}/traits_test.cpp
        ${CPPDAP_SRC_DIR}/typeinfo_test.cpp
        ${CPPDAP_SRC_DIR}/variant_test.cpp
        ${CPPDAP_GOOGLETEST_DIR}/googletest/src/gtest-all.cc
    )

    set(DAP_TEST_INCLUDE_DIR
        ${CPPDAP_GOOGLETEST_DIR}/googlemock/include/
        ${CPPDAP_GOOGLETEST_DIR}/googletest/
        ${CPPDAP_GOOGLETEST_DIR}/googletest/include/
        ${CPPDAP_JSON_DIR}/include/
    )

    add_executable(cppdap-unittests ${DAP_TEST_LIST})

    set_target_properties(cppdap-unittests PROPERTIES
        INCLUDE_DIRECTORIES "${DAP_TEST_INCLUDE_DIR}"
        FOLDER "Tests"
    )

    if(MSVC)
        # googletest emits warning C4244: 'initializing': conversion from 'double' to 'testing::internal::BiggestInt', possible loss of data
        target_compile_options(cppdap-unittests PRIVATE "/wd4244")
    endif()

    cppdap_set_target_options(cppdap-unittests)

    target_link_libraries(cppdap-unittests cppdap "${CPPDAP_OS_LIBS}")
endif(CPPDAP_BUILD_TESTS)

# fuzzer
if(CPPDAP_BUILD_FUZZER)
    if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        message(FATAL_ERROR "CPPDAP_BUILD_FUZZER can currently only be used with the clang toolchain")
    endif()
    set(DAP_FUZZER_LIST
        ${CPPDAP_LIST}
        ${CMAKE_CURRENT_SOURCE_DIR}/fuzz/fuzz.cpp
    )
    add_executable(cppdap-fuzzer ${DAP_FUZZER_LIST})
    if(CPPDAP_ASAN)
        target_compile_options(cppdap-fuzzer PUBLIC "-fsanitize=fuzzer,address")
        target_link_libraries(cppdap-fuzzer "-fsanitize=fuzzer,address")
    elseif(CPPDAP_MSAN)
        target_compile_options(cppdap-fuzzer PUBLIC "-fsanitize=fuzzer,memory")
        target_link_libraries(cppdap-fuzzer "-fsanitize=fuzzer,memory")
    elseif(CPPDAP_TSAN)
        target_compile_options(cppdap-fuzzer PUBLIC "-fsanitize=fuzzer,thread")
        target_link_libraries(cppdap-fuzzer "-fsanitize=fuzzer,thread")
    else()
        target_compile_options(cppdap-fuzzer PUBLIC "-fsanitize=fuzzer")
        target_link_libraries(cppdap-fuzzer "-fsanitize=fuzzer")
    endif()
    target_include_directories(cppdap-fuzzer PUBLIC
        ${CPPDAP_INCLUDE_DIR}
        ${CPPDAP_SRC_DIR}
        ${CPPDAP_JSON_DIR}/include/
    )
    target_link_libraries(cppdap-fuzzer cppdap "${CPPDAP_OS_LIBS}")
endif(CPPDAP_BUILD_FUZZER)

# examples
if(CPPDAP_BUILD_EXAMPLES)
    function(build_example target)
        add_executable(${target} "${CMAKE_CURRENT_SOURCE_DIR}/examples/${target}.cpp")
        set_target_properties(${target} PROPERTIES
            FOLDER "Examples"
        )
        cppdap_set_target_options(${target})
        target_link_libraries(${target} cppdap "${CPPDAP_OS_LIBS}")

        if(CPPDAP_INSTALL_VSCODE_EXAMPLES)
            if(CMAKE_SYSTEM_NAME MATCHES "Windows")
                set(extroot "$ENV{USERPROFILE}\\.vscode\\extensions")
            else()
                set(extroot "$ENV{HOME}/.vscode/extensions")
            endif()
            if(EXISTS ${extroot})
                set(extdir "${extroot}/google.cppdap-example-${target}-1.0.0")
                configure_file(${CMAKE_CURRENT_SOURCE_DIR}/examples/vscode/package.json ${extdir}/package.json)
                add_custom_command(TARGET ${target}
                   POST_BUILD
                   COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:${target}> ${extdir})
            else()
                message(WARNING "Could not install vscode example extension as '${extroot}' does not exist")
            endif()
        endif(CPPDAP_INSTALL_VSCODE_EXAMPLES)
    endfunction(build_example)

    build_example(hello_debugger)

endif(CPPDAP_BUILD_EXAMPLES)

=== 3rdparty/unioncode-GitQlient/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2.0)

project(unioncode-GitQlient)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

#private module AuxiliarWidgets
set(AuxiliarWidgets_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/aux_widgets)
include_directories(${AuxiliarWidgets_DIR})
set(AuxiliarWidgets_FORMS
    ${AuxiliarWidgets_DIR}/BranchDlg.ui
    ${AuxiliarWidgets_DIR}/CreateRepoDlg.ui
    ${AuxiliarWidgets_DIR}/CredentialsDlg.ui
    ${AuxiliarWidgets_DIR}/InitialRepoConfig.ui
    ${AuxiliarWidgets_DIR}/PomodoroConfigDlg.ui
    ${AuxiliarWidgets_DIR}/PullDlg.ui
    ${AuxiliarWidgets_DIR}/SquashDlg.ui
    )
set(AuxiliarWidgets_HEADERS
    ${AuxiliarWidgets_DIR}/BranchDlg.h
    ${AuxiliarWidgets_DIR}/ButtonLink.hpp
    ${AuxiliarWidgets_DIR}/CheckBox.h
    ${AuxiliarWidgets_DIR}/ClickableFrame.h
    ${AuxiliarWidgets_DIR}/Colors.h
    ${AuxiliarWidgets_DIR}/CommitInfoPanel.h
    ${AuxiliarWidgets_DIR}/ConflictButton.h
    ${AuxiliarWidgets_DIR}/CreateRepoDlg.h
    ${AuxiliarWidgets_DIR}/CredentialsDlg.h
    ${AuxiliarWidgets_DIR}/GitQlientUpdater.h
    ${AuxiliarWidgets_DIR}/Highlighter.h
    ${AuxiliarWidgets_DIR}/InitialRepoConfig.h
    ${AuxiliarWidgets_DIR}/PomodoroButton.h
    ${AuxiliarWidgets_DIR}/PomodoroConfigDlg.h
    ${AuxiliarWidgets_DIR}/ProgressDlg.h
    ${AuxiliarWidgets_DIR}/PullDlg.h
    ${AuxiliarWidgets_DIR}/SquashDlg.h
    ${AuxiliarWidgets_DIR}/WaitingDlg.h
    )
set(AuxiliarWidgets_SOURCES
    ${AuxiliarWidgets_DIR}/BranchDlg.cpp
    ${AuxiliarWidgets_DIR}/ButtonLink.cpp
    ${AuxiliarWidgets_DIR}/CheckBox.cpp
    ${AuxiliarWidgets_DIR}/ClickableFrame.cpp
    ${AuxiliarWidgets_DIR}/CommitInfoPanel.cpp
    ${AuxiliarWidgets_DIR}/ConflictButton.cpp
    ${AuxiliarWidgets_DIR}/CreateRepoDlg.cpp
    ${AuxiliarWidgets_DIR}/CredentialsDlg.cpp
    ${AuxiliarWidgets_DIR}/GitQlientUpdater.cpp
    ${AuxiliarWidgets_DIR}/Highlighter.cpp
    ${AuxiliarWidgets_DIR}/InitialRepoConfig.cpp
    ${AuxiliarWidgets_DIR}/PomodoroButton.cpp
    ${AuxiliarWidgets_DIR}/PomodoroConfigDlg.cpp
    ${AuxiliarWidgets_DIR}/ProgressDlg.cpp
    ${AuxiliarWidgets_DIR}/PullDlg.cpp
    ${AuxiliarWidgets_DIR}/SquashDlg.cpp
    ${AuxiliarWidgets_DIR}/WaitingDlg.cpp
    )

set(AuxiliarWidgets_ALL ${AuxiliarWidgets_FORMS} ${AuxiliarWidgets_HEADERS} ${AuxiliarWidgets_SOURCES})

#module bitWidgets
set(BigWidgets_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/big_widgets)
include_directories(${BigWidgets_DIR})
set(BigWidgets_FORMS
    ${BigWidgets_DIR}/ConfigWidget.ui
    )
set(BitWidgets_HEADERS
    ${BigWidgets_DIR}/BlameWidget.h
    ${BigWidgets_DIR}/ConfigWidget.h
    ${BigWidgets_DIR}/Controls.h
    ${BigWidgets_DIR}/DiffWidget.h
    ${BigWidgets_DIR}/GitQlient.h
    ${BigWidgets_DIR}/GitQlientRepo.h
    ${BigWidgets_DIR}/GitQlientSettings.h
    ${BigWidgets_DIR}/GitQlientStyles.h
    ${BigWidgets_DIR}/GitServerWidget.h
    ${BigWidgets_DIR}/HistoryWidget.h
    ${BigWidgets_DIR}/MergeWidget.h
    )
set(BitWidgets_SOURCES
    ${BigWidgets_DIR}/BlameWidget.cpp
    ${BigWidgets_DIR}/ConfigWidget.cpp
    ${BigWidgets_DIR}/Controls.cpp
    ${BigWidgets_DIR}/DiffWidget.cpp
    ${BigWidgets_DIR}/GitQlient.cpp
    ${BigWidgets_DIR}/GitQlientRepo.cpp
    ${BigWidgets_DIR}/GitQlientSettings.cpp
    ${BigWidgets_DIR}/GitQlientStyles.cpp
    ${BigWidgets_DIR}/GitServerWidget.cpp
    ${BigWidgets_DIR}/HistoryWidget.cpp
    ${BigWidgets_DIR}/MergeWidget.cpp
    )
set(BigWidgets_ALL ${BigWidgets_FORMS} ${BitWidgets_HEADERS} ${BitWidgets_SOURCES})

#module branches
set(Branches_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/branches)
include_directories(${Branches_DIR})
set(Branches_FORMS
    ${Branches_DIR}/AddSubmoduleDlg.ui
    ${Branches_DIR}/AddSubtreeDlg.ui
    ${Branches_DIR}/TagDlg.ui
    )
set(Branches_HEADERS
    ${Branches_DIR}/AddRemoteDlg.h
    ${Branches_DIR}/AddSubmoduleDlg.h
    ${Branches_DIR}/AddSubtreeDlg.h
    ${Branches_DIR}/BranchContextMenu.h
    ${Branches_DIR}/BranchTreeWidget.h
    ${Branches_DIR}/BranchesViewDelegate.h
    ${Branches_DIR}/BranchesWidget.h
    ${Branches_DIR}/BranchesWidgetMinimal.h
    ${Branches_DIR}/GitQlientBranchItemRole.h
    ${Branches_DIR}/StashesContextMenu.h
    ${Branches_DIR}/SubmodulesContextMenu.h
    ${Branches_DIR}/TagDlg.h
    )
set(Branches_SOURCES
    ${Branches_DIR}/AddRemoteDlg.cpp
    ${Branches_DIR}/AddSubmoduleDlg.cpp
    ${Branches_DIR}/AddSubtreeDlg.cpp
    ${Branches_DIR}/BranchContextMenu.cpp
    ${Branches_DIR}/BranchTreeWidget.cpp
    ${Branches_DIR}/BranchesViewDelegate.cpp
    ${Branches_DIR}/BranchesWidget.cpp
    ${Branches_DIR}/BranchesWidgetMinimal.cpp
    ${Branches_DIR}/StashesContextMenu.cpp
    ${Branches_DIR}/SubmodulesContextMenu.cpp
    ${Branches_DIR}/TagDlg.cpp
    )
set(Branches_ALL ${Branches_FORMS} ${Branches_HEADERS} ${Branches_SOURCES})

#module commits
set(Commits_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/commits)
include_directories(${Commits_DIR})
set(Commits_FORMS
    ${Commits_DIR}/CommitChangesWidget.ui
    )
set(Commits_HEADERS
    ${Commits_DIR}/AmendWidget.h
    ${Commits_DIR}/CommitChangesWidget.h
    ${Commits_DIR}/CommitInfoWidget.h
    ${Commits_DIR}/FileContextMenu.h
    ${Commits_DIR}/FileListDelegate.h
    ${Commits_DIR}/FileListWidget.h
    ${Commits_DIR}/FileWidget.h
    ${Commits_DIR}/GitQlientRole.h
    ${Commits_DIR}/StagedFilesList.h
    ${Commits_DIR}/UnstagedMenu.h
    ${Commits_DIR}/WipWidget.h
    )
set(Commits_SOURCES
    ${Commits_DIR}/AmendWidget.cpp
    ${Commits_DIR}/CommitChangesWidget.cpp
    ${Commits_DIR}/CommitInfoWidget.cpp
    ${Commits_DIR}/FileContextMenu.cpp
    ${Commits_DIR}/FileListDelegate.cpp
    ${Commits_DIR}/FileListWidget.cpp
    ${Commits_DIR}/FileWidget.cpp
    ${Commits_DIR}/StagedFilesList.cpp
    ${Commits_DIR}/UnstagedMenu.cpp
    ${Commits_DIR}/WipWidget.cpp
    )
set(Commits_ALL ${Commits_FORMS} ${Commits_HEADERS} ${Commits_SOURCES})

#module Config
set(Config_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/config)
include_directories(${Config_DIR})
set(Config_FORMS
    ${Config_DIR}/GitConfigDlg.ui)
set(Config_HEADERS
    ${Config_DIR}/GeneralConfigDlg.h
    ${Config_DIR}/GitConfigDlg.h
    ${Config_DIR}/InitScreen.h
    )
set(Config_SOURCES
    ${Config_DIR}/GeneralConfigDlg.cpp
    ${Config_DIR}/GitConfigDlg.cpp
    ${Config_DIR}/InitScreen.cpp
    )
set(Config_ALL ${Config_FORMS} ${Config_HEADERS} ${Config_SOURCES})

#module Diff
set(Diff_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/diff)
include_directories(${Diff_DIR})
set(Diff_HEADERS
    ${Diff_DIR}/DiffHelper.h
    ${Diff_DIR}/DiffInfo.h
    ${Diff_DIR}/FileBlameWidget.h
    ${Diff_DIR}/FileDiffEditor.h
    ${Diff_DIR}/FileDiffHighlighter.h
    ${Diff_DIR}/FileDiffView.h
    ${Diff_DIR}/FileDiffWidget.h
    ${Diff_DIR}/FileEditor.h
    ${Diff_DIR}/FullDiffWidget.h
    ${Diff_DIR}/IDiffWidget.h
    ${Diff_DIR}/LineNumberArea.h
    )
set(Diff_SOURCES
    ${Diff_DIR}/FileBlameWidget.cpp
    ${Diff_DIR}/FileDiffEditor.cpp
    ${Diff_DIR}/FileDiffHighlighter.cpp
    ${Diff_DIR}/FileDiffView.cpp
    ${Diff_DIR}/FileDiffWidget.cpp
    ${Diff_DIR}/FileEditor.cpp
    ${Diff_DIR}/FullDiffWidget.cpp
    ${Diff_DIR}/IDiffWidget.cpp
    ${Diff_DIR}/LineNumberArea.cpp
    )
set(Diff_ALL ${Diff_HEADERS} ${Diff_SOURCES})

#module Git
set(Git_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/git)
include_directories(${Git_DIR})
set(Git_HEADERS
    ${Git_DIR}/AGitProcess.h
    ${Git_DIR}/GitAsyncProcess.h
    ${Git_DIR}/GitBase.h
    ${Git_DIR}/GitBranches.h
    ${Git_DIR}/GitCloneProcess.h
    ${Git_DIR}/GitConfig.h
    ${Git_DIR}/GitCredentials.h
    ${Git_DIR}/GitExecResult.h
    ${Git_DIR}/GitHistory.h
    ${Git_DIR}/GitLocal.h
    ${Git_DIR}/GitMerge.h
    ${Git_DIR}/GitPatches.h
    ${Git_DIR}/GitRemote.h
    ${Git_DIR}/GitRepoLoader.h
    ${Git_DIR}/GitRequestorProcess.h
    ${Git_DIR}/GitStashes.h
    ${Git_DIR}/GitSubmodules.h
    ${Git_DIR}/GitSubtree.h
    ${Git_DIR}/GitSyncProcess.h
    ${Git_DIR}/GitTags.h
    ${Git_DIR}/GitWip.h
    )
set(Git_SOURCES
    ${Git_DIR}/AGitProcess.cpp
    ${Git_DIR}/GitAsyncProcess.cpp
    ${Git_DIR}/GitBase.cpp
    ${Git_DIR}/GitBranches.cpp
    ${Git_DIR}/GitCloneProcess.cpp
    ${Git_DIR}/GitConfig.cpp
    ${Git_DIR}/GitCredentials.cpp
    ${Git_DIR}/GitExecResult.cpp
    ${Git_DIR}/GitHistory.cpp
    ${Git_DIR}/GitLocal.cpp
    ${Git_DIR}/GitMerge.cpp
    ${Git_DIR}/GitPatches.cpp
    ${Git_DIR}/GitRemote.cpp
    ${Git_DIR}/GitRepoLoader.cpp
    ${Git_DIR}/GitRequestorProcess.cpp
    ${Git_DIR}/GitStashes.cpp
    ${Git_DIR}/GitSubmodules.cpp
    ${Git_DIR}/GitSubtree.cpp
    ${Git_DIR}/GitSyncProcess.cpp
    ${Git_DIR}/GitTags.cpp
    ${Git_DIR}/GitWip.cpp
    )
set(Git_ALL ${Git_HEADERS} ${Git_SOURCES})

#module Cache
set(Cache_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/cache)
include_directories(${Cache_DIR})
set(Cache_HEADERS
    ${Cache_DIR}/CommitInfo.h
    ${Cache_DIR}/GitCache.h
    ${Cache_DIR}/GitServerCache.h
    ${Cache_DIR}/Lane.h
    ${Cache_DIR}/LaneType.h
    ${Cache_DIR}/References.h
    ${Cache_DIR}/RevisionFiles.h
    ${Cache_DIR}/WipRevisionInfo.h
    ${Cache_DIR}/lanes.h
    )
set(Cache_SOURCES
    ${Cache_DIR}/CommitInfo.cpp
    ${Cache_DIR}/GitCache.cpp
    ${Cache_DIR}/GitServerCache.cpp
    ${Cache_DIR}/Lane.cpp
    ${Cache_DIR}/References.cpp
    ${Cache_DIR}/RevisionFiles.cpp
    ${Cache_DIR}/lanes.cpp
    )
set(Cache_ALL ${Cache_HEADERS} ${Cache_SOURCES})

#module History
set(History_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/history)
include_directories(${History_DIR})
set(History_HEADERS
    ${History_DIR}/CommitHistoryColumns.h
    ${History_DIR}/CommitHistoryContextMenu.h
    ${History_DIR}/CommitHistoryModel.h
    ${History_DIR}/CommitHistoryView.h
    ${History_DIR}/RepositoryViewDelegate.h
    ${History_DIR}/ShaFilterProxyModel.h
    )
set(History_SOURCES
    ${History_DIR}/CommitHistoryContextMenu.cpp
    ${History_DIR}/CommitHistoryModel.cpp
    ${History_DIR}/CommitHistoryView.cpp
    ${History_DIR}/RepositoryViewDelegate.cpp
    ${History_DIR}/ShaFilterProxyModel.cpp
    )
set(History_ALL ${History_DIR} ${History_SOURCES})

#module gitServer
set(GitServer_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/git_server)
include_directories(${GitServer_DIR})
set(GitServer_HEADERS
    ${GitServer_DIR}/Comment.h
    ${GitServer_DIR}/Commit.h
    ${GitServer_DIR}/ConfigData.h
    ${GitServer_DIR}/GitHubRestApi.h
    ${GitServer_DIR}/GitLabRestApi.h
    ${GitServer_DIR}/IRestApi.h
    ${GitServer_DIR}/Issue.h
    ${GitServer_DIR}/Label.h
    ${GitServer_DIR}/Milestone.h
    ${GitServer_DIR}/Platform.h
    ${GitServer_DIR}/PullRequest.h
    ${GitServer_DIR}/User.h
    )
set(GitServer_SOURCES
    ${GitServer_DIR}/GitHubRestApi.cpp
    ${GitServer_DIR}/GitLabRestApi.cpp
    ${GitServer_DIR}/IRestApi.cpp
    )
set(GitServer_ALL ${GitServer_HEADERS} ${GitServer_SOURCES})

#module gitServerWidgets
#    ${GitServerWidgets_DIR}/CreatePullRequestDlg.ui
#    ${GitServerWidgets_DIR}/CreatePullRequestDlg.h
#    ${GitServerWidgets_DIR}/CreatePullRequestDlg.cpp
#    ${GitServerWidgets_DIR}/CreateIssueDlg.ui
#    ${GitServerWidgets_DIR}/CreateIssueDlg.h
#    ${GitServerWidgets_DIR}/CreateIssueDlg.cpp
set(GitServerWidgets_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/git_server)
include_directories(${GitServerWidgets_DIR})
set(GitServerWidgets_FORMS
    ${GitServerWidgets_DIR}/AddCodeReviewDialog.ui
    ${GitServerWidgets_DIR}/MergePullRequestDlg.ui
    ${GitServerWidgets_DIR}/ServerConfigDlg.ui
    )
set(GitServerWidgets_HEADERS
    ${GitServerWidgets_DIR}/AddCodeReviewDialog.h
    ${GitServerWidgets_DIR}/AGitServerItemList.h
    ${GitServerWidgets_DIR}/AvatarHelper.h
    ${GitServerWidgets_DIR}/CircularPixmap.h
    ${GitServerWidgets_DIR}/CodeReviewComment.h
    ${GitServerWidgets_DIR}/IssueDetailedView.h
    ${GitServerWidgets_DIR}/IssueItem.h
    ${GitServerWidgets_DIR}/IssuesList.h
    ${GitServerWidgets_DIR}/MergePullRequestDlg.h
    ${GitServerWidgets_DIR}/PrChangeListItem.h
    ${GitServerWidgets_DIR}/PrChangesList.h
    ${GitServerWidgets_DIR}/PrCommentsList.h
    ${GitServerWidgets_DIR}/PrCommitsList.h
    ${GitServerWidgets_DIR}/PrList.h

=== 3rdparty/unioncode-qscintilla214/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(unioncode-qscintilla)
set(CMAKE_CXX_STANDARD 17)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(Qt5 COMPONENTS
    Widgets
    PrintSupport
    REQUIRED)
find_package(Dtk COMPONENTS Widget REQUIRED)

file(GLOB_RECURSE SRCS CONFIGURE_DEPENDS
    "${CMAKE_CURRENT_SOURCE_DIR}/src/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/Qsci/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/Qsci/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/scintilla/*/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/scintilla/*/*.cpp"
)

add_definitions(-DSCINTILLA_QT -DSCI_LEXER -DINCLUDE_DEPRECATED_FEATURES)

add_library(${PROJECT_NAME} ${SRCS})

target_include_directories(${PROJECT_NAME}
    PRIVATE
        ${DtkWidget_INCLUDE_DIRS}
        ${CMAKE_CURRENT_SOURCE_DIR}/scintilla/include
        ${CMAKE_CURRENT_SOURCE_DIR}/scintilla/src
        ${CMAKE_CURRENT_SOURCE_DIR}/scintilla/lexlib
        ${CMAKE_CURRENT_SOURCE_DIR}/src
        ${CMAKE_CURRENT_SOURCE_DIR}/src/Qsci
)

target_link_libraries(
    ${PROJECT_NAME}
    Qt5::Widgets
    Qt5::PrintSupport
    ${DtkWidget_LIBRARIES}
)

install(TARGETS ${PROJECT_NAME} ARCHIVE DESTINATION ${LIBRARY_INSTALL_PREFIX})

=== 3rdparty/unioncode-qtermwidget-0.14.1/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0 FATAL_ERROR)
# CMP0000: Call the cmake_minimum_required() command at the beginning of the top-level
# CMakeLists.txt file even before calling the project() command.
# The cmake_minimum_required(VERSION) command implicitly invokes the cmake_policy(VERSION)
# command to specify that the current project code is written for the given range of CMake
# versions.
project(qtermwidget)

#include(GNUInstallDirs)
include(GenerateExportHeader)
#include(CMakePackageConfigHelpers)
include(CheckFunctionExists)
#include(CheckIncludeFile)

option(UPDATE_TRANSLATIONS "Update source translation translations/*.ts files" OFF)
option(BUILD_EXAMPLE "Build example application. Default OFF." OFF)
option(QTERMWIDGET_USE_UTEMPTER "Uses the libutempter library. Mainly for FreeBSD" OFF)
option(QTERMWIDGET_BUILD_PYTHON_BINDING "Build python binding" OFF)
option(USE_UTF8PROC "Use libutf8proc for better Unicode support. Default OFF" OFF)

#set(QTERMWIDGET_VERSION "${QTERMWIDGET_VERSION_MAJOR}.${QTERMWIDGET_VERSION_MINOR}.${QTERMWIDGET_VERSION_PATCH}")

# additional cmake files
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake")
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Minimum Versions
set(QT_MINIMUM_VERSION "5.7.1")
set(LXQTBT_MINIMUM_VERSION "0.6.0")

find_package(Qt5Widgets "${QT_MINIMUM_VERSION}" REQUIRED)
find_package(Qt5LinguistTools "${QT_MINIMUM_VERSION}" REQUIRED)
find_package(lxqt-build-tools ${LXQTBT_MINIMUM_VERSION} REQUIRED)

if(USE_UTF8PROC)
    find_package(Utf8Proc REQUIRED)
endif()

include(LXQtPreventInSourceBuilds)
include(LXQtTranslateTs)
include(LXQtCompilerSettings NO_POLICY_SCOPE)
#include(LXQtCreatePkgConfigFile)

set(QTERMWIDGET_LIBRARY_NAME unioncode-qtermwidget)

# main library
set(SRCS
    lib/BlockArray.cpp
    lib/ColorScheme.cpp
    lib/Emulation.cpp
    lib/Filter.cpp
    lib/History.cpp
    lib/HistorySearch.cpp
    lib/KeyboardTranslator.cpp
    lib/konsole_wcwidth.cpp
    lib/kprocess.cpp
    lib/kpty.cpp
    lib/kptydevice.cpp
    lib/kptyprocess.cpp
    lib/Pty.cpp
    lib/qtermwidget.cpp
    lib/Screen.cpp
    lib/ScreenWindow.cpp
    lib/SearchBar.cpp
    lib/Session.cpp
    lib/ShellCommand.cpp
    lib/TerminalCharacterDecoder.cpp
    lib/TerminalDisplay.cpp
    lib/tools.cpp
    lib/Vt102Emulation.cpp
)

# Only the Headers that need to be moc'd go here
set(HDRS
    lib/Emulation.h
    lib/Filter.h
    lib/HistorySearch.h
    lib/kprocess.h
    lib/kptydevice.h
    lib/kptyprocess.h
    lib/Pty.h
    lib/qtermwidget.h
    lib/ScreenWindow.h
    lib/SearchBar.h
    lib/Session.h
    lib/TerminalDisplay.h
    lib/Vt102Emulation.h
)

set(UI
    lib/SearchBar.ui
)

# for distribution
set(HDRS_DISTRIB
    lib/qtermwidget.h
    lib/Emulation.h
    lib/Filter.h
)

# dirs
set(KB_LAYOUT_DIR "${SOURCES_INSTALL_RPEFIX}/${QTERMWIDGET_LIBRARY_NAME}/kb-layouts")
message(STATUS "Keyboard layouts will be installed in: ${KB_LAYOUT_DIR}")

set(COLORSCHEMES_DIR "${SOURCES_INSTALL_RPEFIX}/${QTERMWIDGET_LIBRARY_NAME}/color-schemes")
message(STATUS "Color schemes will be installed in: ${COLORSCHEMES_DIR}" )

set(TRANSLATIONS_DIR "${SOURCES_INSTALL_RPEFIX}/${QTERMWIDGET_LIBRARY_NAME}/translations")
message(STATUS "Translations will be installed in: ${TRANSLATIONS_DIR}")

CHECK_FUNCTION_EXISTS(updwtmpx HAVE_UPDWTMPX)

qt5_wrap_cpp(MOCS ${HDRS})
qt5_wrap_ui(UI_SRCS ${UI})
set(PKG_CONFIG_REQ "Qt5Widgets")

lxqt_translate_ts(QTERMWIDGET_QM
    TRANSLATION_DIR "lib/translations"
    UPDATE_TRANSLATIONS
        ${UPDATE_TRANSLATIONS}
    SOURCES
        ${SRCS} ${HDRS} ${UI}
    INSTALL_DIR
        ${TRANSLATIONS_DIR}
    COMPONENT
        Runtime
)

add_library(${QTERMWIDGET_LIBRARY_NAME} SHARED ${SRCS} ${MOCS} ${UI_SRCS} ${QTERMWIDGET_QM})
target_link_libraries(${QTERMWIDGET_LIBRARY_NAME} Qt5::Widgets)

if(APPLE)
    target_compile_definitions(${QTERMWIDGET_LIBRARY_NAME}
        PRIVATE
            "HAVE_UTMPX"
            "UTMPX_COMPAT"
    )
endif()

if(HAVE_UPDWTMPX)
    target_compile_definitions(${QTERMWIDGET_LIBRARY_NAME}
        PRIVATE
            "HAVE_UPDWTMPX"
    )
endif()

if (QTERMWIDGET_USE_UTEMPTER)
    CHECK_INCLUDE_FILE(utempter.h HAVE_UTEMPTER)
    if (HAVE_UTEMPTER)
        target_compile_definitions(${QTERMWIDGET_LIBRARY_NAME} PRIVATE
                "HAVE_UTEMPTER"
        )
        target_link_libraries(${QTERMWIDGET_LIBRARY_NAME} ulog)
    endif()
endif()

if (UTF8PROC_FOUND)
    target_compile_definitions(${QTERMWIDGET_LIBRARY_NAME}
        PRIVATE
            "HAVE_UTF8PROC"
    )
    target_include_directories(${QTERMWIDGET_LIBRARY_NAME}
        INTERFACE
            ${UTF8PROC_INCLUDE_DIRS}
    )
    target_link_libraries(${QTERMWIDGET_LIBRARY_NAME}
        ${UTF8PROC_LIBRARIES}
    )
    string(APPEND PKG_CONFIG_REQ ", libutf8proc")
endif()

if(APPLE)
    set (CMAKE_SKIP_RPATH 1)
    # this is a must to load the lib correctly
    set_target_properties(${QTERMWIDGET_LIBRARY_NAME} PROPERTIES INSTALL_NAME_DIR ${CMAKE_INSTALL_FULL_LIBDIR})
endif()

target_compile_definitions(${QTERMWIDGET_LIBRARY_NAME}
    PRIVATE
        "KB_LAYOUT_DIR=\"${KB_LAYOUT_DIR}\""
        "COLORSCHEMES_DIR=\"${COLORSCHEMES_DIR}\""
        "TRANSLATIONS_DIR=\"${TRANSLATIONS_DIR}\""
        "HAVE_POSIX_OPENPT"
        "HAVE_SYS_TIME_H"
        "QT_USE_QSTRINGBUILDER"
        "QT_NO_CAST_FROM_ASCII"
        "QT_NO_CAST_TO_ASCII"
        "QT_NO_URL_CAST_FROM_STRING"
        "QT_NO_CAST_FROM_BYTEARRAY"
)


generate_export_header(${QTERMWIDGET_LIBRARY_NAME}
    EXPORT_FILE_NAME "${CMAKE_CURRENT_BINARY_DIR}/lib/qtermwidget_export.h"
    EXPORT_MACRO_NAME QTERMWIDGET_EXPORT
)

target_include_directories(${QTERMWIDGET_LIBRARY_NAME}
    PUBLIC
        "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lib>"
        "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/lib>"
    INTERFACE
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${QTERMWIDGET_LIBRARY_NAME}>"
)

# keyboard layouts
install(DIRECTORY
    lib/kb-layouts/
    DESTINATION "${KB_LAYOUT_DIR}"
    COMPONENT Runtime
    FILES_MATCHING PATTERN "*.keytab"
)
# color schemes
install(DIRECTORY
    lib/color-schemes/
    DESTINATION "${COLORSCHEMES_DIR}"
    COMPONENT Runtime
    FILES_MATCHING PATTERN "*.*schem*"
)

install(TARGETS ${QTERMWIDGET_LIBRARY_NAME} LIBRARY DESTINATION ${LIBRARY_INSTALL_PREFIX})

=== src/app/CMakeLists.txt ===
project(deepin-unioncode)

add_executable(${PROJECT_NAME} main.cpp)

add_definitions(
    -DEXTEND_BACKTRACE
    )

target_link_libraries(
    ${PROJECT_NAME}
    framework
    common
    ${QtUseModules}
    ${PkgUseModule}
    ${DtkWidget_LIBRARIES}
    )

install(TARGETS ${PROJECT_NAME} DESTINATION ${RUNTIME_INSTALL_RPEFIX})

=== src/base/CMakeLists.txt ===
project(base)

FILE(GLOB_RECURSE PROJECT_SOURCES
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
)

add_library(
    ${PROJECT_NAME}
    STATIC
    ${PROJECT_SOURCES}
)

target_link_libraries(
    ${PROJECT_NAME}
    ${DtkWidget_LIBRARIES}
)

install(TARGETS ${PROJECT_NAME} DESTINATION ${LIBRARY_INSTALL_PREFIX})

=== src/common/CMakeLists.txt ===
project(common)

include(${CMAKE_SOURCE_DIR}/3rdparty/unioncode-jsonrpccpp.cmake)

install(FILES ${CMAKE_SOURCE_DIR}/src/common/resource/icons/ide.svg DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps/)

configure_file(util/config.h.in config.h)
find_package(Qt5Network)

set(CMAKE_CXX_STANDARD 17)

add_definitions(
    -DCOMMON_LIBRARY
    )

FILE(GLOB COMMON_FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*/*/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*/*/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.json"
    )

add_library(
    ${PROJECT_NAME}
    SHARED
    ${COMMON_FILES}
    resource/common.qrc
    )
    
target_include_directories(${PROJECT_NAME}
    PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}
)

target_link_libraries(
    ${PROJECT_NAME}
    unioncode-jsonrpcclient
    Qt5::Network
    ${DtkWidget_LIBRARIES}
    )

install(TARGETS ${PROJECT_NAME} DESTINATION ${LIBRARY_INSTALL_PREFIX})

=== src/framework/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)

project(framework)

add_definitions(
    -DDPF_LIBRARY
    )

#set Module subdir
#   The module pattern cannot be broken, 
#   so the installation header file cannot be found
set(lifecycle ${CMAKE_CURRENT_SOURCE_DIR}/lifecycle)
set(listener ${CMAKE_CURRENT_SOURCE_DIR}/listener)
set(service ${CMAKE_CURRENT_SOURCE_DIR}/service)
set(event ${CMAKE_CURRENT_SOURCE_DIR}/event)
set(log ${CMAKE_CURRENT_SOURCE_DIR}/log)
set(listener ${CMAKE_CURRENT_SOURCE_DIR}/listener)

set(LOBAL_H
    framework_global.h
    )

set(PRIVATE_H
    lifecycle/private/pluginmanager_p.h
    lifecycle/private/pluginmetaobject_p.h
    event/private/event_p.h
    )

set(PRIVATE_CPP
    lifecycle/private/pluginmanager_p.cpp
    )

set(PUBLIC_H
    event/event.h
    event/eventcallproxy.h
    event/eventhandler.h
    log/frameworklog.h
    log/codetimecheck.h
    log/logutils.h
    service/qtclassmanager.h
    service/qtclassfactory.h
    service/pluginservicecontext.h
    service/pluginservice.h
    lifecycle/pluginsetting.h
    lifecycle/pluginmetaobject.h
    lifecycle/plugin.h
    lifecycle/pluginmanager.h
    lifecycle/lifecycle.h
    lifecycle/plugindepend.h
    listener/private/listener_p.h
    listener/listener.h
    backtrace/backtrace.h
    framework.h
    )

set(PUBLIC_CPP
    event/event.cpp
    event/eventcallproxy.cpp
    event/eventhandler.cpp
    log/frameworklog.cpp
    log/codetimecheck.cpp
    log/logutils.cpp
    lifecycle/pluginsetting.cpp
    lifecycle/pluginmetaobject.cpp
    lifecycle/plugin.cpp
    lifecycle/pluginmanager.cpp
    lifecycle/lifecycle.cpp
    service/pluginservicecontext.cpp
    listener/listener.cpp
    backtrace/backtrace.cpp
    framework.cpp
    )

add_library(${PROJECT_NAME} SHARED
    ${LOBAL_H}
    ${PRIVATE_H}
    ${PRIVATE_CPP}
    ${PUBLIC_H}
    ${PUBLIC_CPP}
    )

target_link_libraries(
    ${PROJECT_NAME}
    stdc++fs
    ${QtUseModules}
    ${PkgUseModules}
    ${DtkWidget_LIBRARIES}
)

target_include_directories(${PROJECT_NAME}
    PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}
)
add_library(DFM::framework ALIAS ${PROJECT_NAME})

#install library file
install(TARGETS
    ${PROJECT_NAME}
    DESTINATION
    ${LIBRARY_INSTALL_PREFIX}
    )

#recursion install head file
install(DIRECTORY
    ${CMAKE_CURRENT_SOURCE_DIR}
    DESTINATION
    ${INCLUDE_INSTALL_RPEFIX}
    FILES_MATCHING PATTERN "*.h"
    )

=== debian/changelog ===
deepin-unioncode (1.3.8) unstable; urgency=medium

  * Fix some bugs

 -- luzhen <luzhen@uniontech.com>  Wed, 07 Aug 2024 10:11:48 +0800

deepin-unioncode (1.3.7) unstable; urgency=medium

  * Optimize searcher
  * Add symbol tree
  * Add linglong
  * bug fix

 -- luzhen <luzhen@uniontech.com>  Mon, 22 Jul 2024 16:32:09 +0800

deepin-unioncode (1.3.4) unstable; urgency=medium

  * Bug fix
  * Optimize LSP

 -- luzhen <luzhen@uniontech.com>  Wed, 26 Jun 2024 15:31:26 +0800

deepin-unioncode (1.3.1) unstable; urgency=medium

  * Change toolbar layout
  * Optimize debugger
  * Bug fix

 -- luzhen <luzhen@uniontech.com>  Mon, 03 Jun 2024 13:48:11 +0800

deepin-unioncode (1.3.0) unstable; urgency=medium

  * Add file manager plugin template
  * Add git in editor
  * Add process plugin

 -- luzhen <luzhen@uniontech.com>  Fri, 17 May 2024 15:16:33 +0800

deepin-unioncode (1.2.18) unstable; urgency=medium

  * Bug fix

 -- luzhen <luzhen@uniontech.com>  Wed, 24 Apr 2024 17:08:30 +0800

deepin-unioncode (1.2.17) unstable; urgency=medium

  * bug fix

 -- luzhen <luzhen@uniontech.com>  Sun, 07 Apr 2024 13:31:00 +0800

deepin-unioncode (1.2.16) unstable; urgency=medium

  * Optimize editor
  * Optimize debugger
  * Bug fix

 -- luzhen <luzhen@uniontech.com>  Tue, 02 Apr 2024 16:47:51 +0800

deepin-unioncode (1.2.15) unstable; urgency=medium

  * bug fix

 -- luzhen <luzhen@uniontech.com>  Mon, 18 Mar 2024 17:42:15 +0800

deepin-unioncode (1.2.14) unstable; urgency=medium

  * bug fix

 -- luzhen <luzhen@uniontech.com>  Thu, 07 Mar 2024 10:35:04 +0800

deepin-unioncode (1.2.13) unstable; urgency=medium

  * bug fix

 -- luzhen <luzhen@uniontech.com>  Wed, 06 Mar 2024 14:46:49 +0800

deepin-unioncode (1.2.12) unstable; urgency=medium

  * Project tree optimization
  * LSP optimization

 -- luzhen <luzhen@uniontech.com>  Fri, 01 Mar 2024 14:44:12 +0800

deepin-unioncode (1.2.11) unstable; urgency=medium

  * LSP optimization
  * Add locator
  * Add extension manager

 -- luzhen <luzhen@uniontech.com>  Wed, 21 Feb 2024 14:49:42 +0800

deepin-unioncode (1.2.10) unstable; urgency=medium

  * Replace editor
  * Refactor core
  * Optimize project manager

 -- luzhen <luzhen@uniontech.com>  Mon, 05 Feb 2024 10:27:32 +0800

deepin-unioncode (1.2.9) unstable; urgency=medium

  * bug fix.

 -- luzhen <luzhen@uniontech.com>  Wed, 03 Jan 2024 10:12:22 +0800

deepin-unioncode (1.2.8) unstable; urgency=medium

  * Community v23

 -- luzhen <luzhen@uniontech.com>  Thu, 21 Dec 2023 16:16:49 +0800

deepin-unioncode (1.2.7) unstable; urgency=medium

  * Community version

 -- luzhen <luzhen@uniontech.com>  Tue, 19 Dec 2023 17:47:40 +0800

deepin-unioncode (1.2.6) unstable; urgency=medium

  * Bug fix

 -- luzhen <luzhen@uniontech.com>  Tue, 19 Dec 2023 16:27:28 +0800

deepin-unioncode (1.2.5) unstable; urgency=medium

  * Fix the problem of blurry icons in launcher and taskbar
  * Fixed syntax highlighting exception after upgrade
  * Improve the About dialog box
  * Fix the problem that the dde-clipboard project tree cannot be displayed
  * Add loading animation during startup
  * Zhipu AI model is updated to support querying DTK related issues. 

 -- luzhen <luzhen@uniontech.com>  Mon, 18 Dec 2023 21:46:03 +0800

deepin-unioncode (1.2.4) unstable; urgency=medium

  * add clangd-13
  * bug fix

 -- luzhen <luzhen@uniontech.com>  Fri, 15 Dec 2023 10:38:26 +0800

deepin-unioncode (1.2.3) unstable; urgency=medium

  * compile on multi-platforms

 -- luzhen <luzhen@uniontech.com>  Wed, 13 Dec 2023 13:18:49 +0800

deepin-unioncode (1.2.2) unstable; urgency=medium

  * bug fix

 -- luzhen <luzhen@uniontech.com>  Tue, 12 Dec 2023 21:00:19 +0800

deepin-unioncode (1.2.1) unstable; urgency=medium

  * bug fix

 -- luzhen <luzhen@uniontech.com>  Fri, 08 Dec 2023 17:47:43 +0800

deepin-unioncode (1.2.0) unstable; urgency=medium

  * Add Codegeex plugin
  * Change qt to dtk

 -- Deepin Packages Builder <packages@linuxdeepin.com>  Mon, 04 Dec 2023 10:04:27 +0800

deepin-unioncode (1.1.20) unstable; urgency=medium

  * 

 -- Deepin Packages Builder <pakcages@linuxdeepin.com>  Fri, 20 Oct 2023 14:07:51 +0800

deepin-unioncode (1.1.19) unstable; urgency=medium

  * 

 -- Deepin Packages Builder <packages@linuxdeepin.com>  Fri, 01 Sep 2023 19:35:11 +0800

=== debian/control ===
Source: deepin-unioncode
Section: libdevel
Priority: optional
Maintainer: Deepin Packages Builder <packages@linuxdeepin.com>
Build-Depends:
 debhelper (>=9),
 cmake,
 qt5-qmake,
 qtbase5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 qtwebengine5-dev[!loong64],
 lxqt-build-tools (>= 0.6.0~),
 libssl-dev,
 llvm (>=1:7~),
 llvm-dev (>=1:7~),
 libclang-dev (>=1:7~),
 libutf8proc-dev,
 libmicrohttpd-dev,
 libjsoncpp-dev,
 libargtable2-dev,
 libhiredis-dev,
 catch,
 libzstd-dev,
 libjson-c-dev,
 libelf-dev,
 libcapstone-dev,
 libunwind-dev, 
 libelfin-dev,
 libdbus-1-dev,
 libxi-dev,
 qtscript5-dev,
 libqt5scripttools5,
 clang[!mips64],
 doxygen,
 libdtkgui-dev,
 libdtkwidget-dev,
 libdtkcore-dev,
 libdtkcore5-bin,
 libkf5syntaxhighlighting-dev,
 libyaml-cpp-dev
Standards-version: 3.9.8
Homepage: http://www.deepin.org

Package: deepin-unioncode
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Recommends: cmake,
            make,
            gdb,
            g++,
            gcc,
            git,
            clangd-13|clangd,
            python3-pip
Description: IDE 'Deepin Union Code'
 Lightweight cross-platform integrated development environment

Package: libdeepin-unioncode-dev
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: IDE 'Union Code' devel library
 IDE 'Union Code' development can be carried out through this library
